﻿using Xamarin.Forms;
using Syncfusion.SfCalendar.XForms;
using System;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.ComponentModel;

namespace CalendarSample
{
	public partial class CalendarSamplePage : ContentPage
	{
		SfCalendar cal = new SfCalendar();

		public CalendarSamplePage()
		{
			InitializeComponent();
			MonthViewSettings mon = new MonthViewSettings();
			mon.HeaderBackgroundColor = Color.Orange;
			cal.MonthViewSettings = mon;
			cal.OnInlineLoaded+=HandleDrawInlineEventHandler;
			cal.InlineToggled += Tappedevent;
			cal.ShowInlineEvents = true;
			CalendarInlineEvent events = new CalendarInlineEvent();
			events.StartTime = new DateTime(2017, 6, 11);
			events.EndTime = new DateTime(2017, 6, 12);
			events.Subject = "Go to Meeting";
			CalendarInlineEvent events12 = new CalendarInlineEvent();
			events12.StartTime = new DateTime(2017, 6, 1);
			events12.EndTime = new DateTime(2017, 6, 2);
			events12.Subject = "TestingEvent";
			CalendarInlineEvent events1 = new CalendarInlineEvent();
			events1.StartTime = new DateTime(2017, 6, 11);
			events1.EndTime = new DateTime(2017, 6, 15);
			events1.Subject = "Meeting";
			CalendarInlineEvent events2 = new CalendarInlineEvent();
			events2.StartTime = new DateTime(2017, 6, 6);
			events2.EndTime = new DateTime(2017, 6, 9);
			events2.Subject = "Meeting2";
			CalendarInlineEvent events3 = new CalendarInlineEvent();
			events3.StartTime = new DateTime(2017, 6, 22);
			events3.EndTime = new DateTime(2017, 6, 23);
			events3.Subject = "Meeting3";
			CalendarInlineEvent events4 = new CalendarInlineEvent();
			events4.StartTime = new DateTime(2017, 6, 19);
			events4.EndTime = new DateTime(2017, 6, 21);
			events4.Subject = "Meeting4";
			CalendarEventCollection collection = new CalendarEventCollection();
			collection.Add(events);
			collection.Add(events12);
			collection.Add(events);
			collection.Add(events12);
			collection.Add(events2);
			collection.Add(events3);
			collection.Add(events4);
			cal.DataSource = collection;
			Content = cal;

		}
	
		void Tappedevent(object sender, InlineToggledEventArgs args)
		{


		}

		void HandleDrawInlineEventHandler(object sender, InlineEventArgs args)
		{
			ViewModel vm = new ViewModel();

			for (int i = 0; i < args.appointments.Count; i++)
			{
				vm.Collection.Add(new Model() { Subject = args.appointments[i].Subject });
			}
			CustomInlineView inlineView= new CustomInlineView(this) { BindingContext = vm };
			StackLayout stk = new StackLayout();
			stk.HeightRequest = 150;
			stk.Children.Add(inlineView);
			args.View = inlineView;
		}
	
	}

	public class ViewModel:INotifyPropertyChanged
	{
		private List<Model> collection = new List<Model>();

		public List<Model> Collection
		{
			get
			{
				return collection;
			}

			set
			{
				collection = value;
				OnPropertyChanged("Collection");
			}
		}
		protected virtual void OnPropertyChanged(string propertyName)
		{
			PropertyChangedEventHandler handler = PropertyChanged;
			if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
		}

		public event PropertyChangedEventHandler PropertyChanged;
	}
	public class Model
	{
		private string subject;

		public string Subject
		{
			get
			{
				return subject;
			}
			set 
			{
				subject=value;
			}
		}

	}
}

